 #include<reg51.h>
#define uchar unsigned char
#define uint unsigned int
sbit LED1=P1^0;
sbit LED2=P1^3;
sbit K2=P1^7;
uchar NumX=-1;
//延时
void DelayMS(uint ms)
{
uchar i;
while(ms--) for(i=0;i<120;i++);
}
//主程序
void main()
{
LED1=LED2=1;
SCON=0x50; //串口模式1，允许接收
TMOD=0x20; //T1 工作模式2TH1=0xfd; //波特率9600
TL1=0xfd;
PCON=0x00; //波特率不倍增
RI=TI=0;
TR1=1;
IE=0x90;
while(1)
{
DelayMS(100);
if(K2==0)
{
while(K2==0);
NumX=++NumX%11; //产生0~10 范围内的数字，其中10 表示关闭
SBUF=NumX;
while(TI==0);
TI=0;
}
}
}
void Serial_INT() interrupt 4
{
if(RI) //如收到则LED 则动作
{
RI=0;
switch(SBUF) //根据所收到的不同命令字符完成不同动作
{
case 'X': LED1=LED2=1;break; //全灭
case 'A': LED1=0;LED2=1;break; //LED1 亮
case 'B': LED2=0;LED1=1;break; //LED2 亮
case 'C': LED1=LED2=0; //全亮
}
}
}